/*
 * Test fl_create via IPV6_FL_A_GET, which tries to get a flowlabel lease.
 */
#include <err.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h> 
#include <arpa/inet.h>
#include <netinet/in.h>
#include <linux/in6.h>
#include <arpa/inet.h>

#define ADDR "::1"

int main(void)
{
	int fd, ret;
	u_int32_t label = 1;
	struct in6_flowlabel_req freq;
	struct in6_addr addr;
	
	ret = inet_pton(AF_INET6, ADDR, &addr);
	if (ret < 0)
		err(1, "inet_pton");
	 
	fd = socket(PF_INET6, SOCK_DGRAM, 0);
	if (fd < 0)
		err(1, "socket");
	
	memset(&freq, 0, sizeof(freq));
	freq.flr_label = htonl(label);
	freq.flr_action = IPV6_FL_A_GET;
	freq.flr_flags = IPV6_FL_F_CREATE|IPV6_FL_F_EXCL;
	freq.flr_share = IPV6_FL_F_EXCL;
	memcpy(&freq.flr_dst, &addr, sizeof(addr));
	
	ret = setsockopt(fd, SOL_IPV6, IPV6_FLOWLABEL_MGR, &freq, sizeof(freq));
	if (ret < 0)
		err(1, "setsockopt");
	
	while (1)
		sleep(1);

	return 0;
}

	
